__kernel void matAdd( __global float *A, __global float *B, __global float* C, int m, int n ) {
    int i = get_global_id(0);
    for(int j=0; j < n; j++)
      C[i*n+j] = A[i*n+j] + B[i*n+j];
}

void basicSgemm( int m, int n, cl_mem A, cl_mem B, cl_mem C, cl_kernel clKernel, cl_command_queue clCommandQueue )
{
  size_t global_work_group = m;

  clSetKernelArg(clKernel,0,sizeof(cl_mem),(void*)&A);
  clSetKernelArg(clKernel,1,sizeof(cl_mem),(void*)&B);
  clSetKernelArg(clKernel,2,sizeof(cl_mem),(void*)&C);
  clSetKernelArg(clKernel,3,sizeof(int),(void*)&m);
  clSetKernelArg(clKernel,4,sizeof(int),(void*)&n);

  clEnqueueNDRangeKernel(clCommandQueue, clKernel, 1, NULL,
      &global_work_group, NULL, 0, NULL, NULL);

  clFinish(clCommandQueue); 
}
