/***************************************************************************
 *cr
 *cr            (C) Copyright 2010 The Board of Trustees of the
 *cr                        University of Illinois
 *cr                         All Rights Reserved
 *cr
 ***************************************************************************/

/* 
 * Kernel of dense matrix-matrix multiplication kernel.
 */

__kernel void matAdd( __global float *A, __global float *B, __global float* C, int m, int n )
{
/*#ifdef ROWM*/
    /*int i = get_group_id(0);*/
    /*int j = get_local_id(0);*/
/*#else*/
    /*int i = get_local_id(0);*/
    /*int j = get_group_id(0);*/
/*#endif*/
    /*C[i*n+j] = A[i*n+j] + B[i*n+j];*/
#ifdef ROWM
    int i = get_global_id(0);
    for(int j=0; j < n; j++)
      C[i*n+j] = A[i*n+j] + B[i*n+j];
#else
    int j = get_global_id(0);
    for(int i=0; i < m; i++)
      C[i*n+j] = A[i*n+j] + B[i*n+j];
#endif
}
