/***************************************************************************
 *cr
 *cr            (C) Copyright 2010 The Board of Trustees of the
 *cr                        University of Illinois
 *cr                         All Rights Reserved
 *cr
 ***************************************************************************/

/* 
 * Kernel of dense matrix-matrix multiplication kernel.
 */

__kernel void mysgemmNT( __global const float *A, int lda, __global const float *B, int ldb, __global float* C, int ldc, int k, float alpha, float beta )
{
    float c = 0.0f;
    int m = get_global_id(0);
    int n = get_global_id(1);

    for (int i = 0; i < k; ++i) {
        float a = A[m + i * lda];
        float b = B[n + i * ldb];
        c += a * b;
    }
    C[m+n*ldc] = C[m+n*ldc] * beta + alpha * c;

    /*float8 cp = (float8)(0.0f);*/

    /*int m = get_global_id(0) * 8;*/
    /*int n = get_global_id(1);*/

    /*for (int i = 0; i < k; ++i) {*/
        /*float8 a = vload8(0, A + (m + i * lda));*/
        /*float8 b = (float8)(B[n + i * ldb]);*/
        /*cp += a * b;*/
    /*}*/

    /*float8 c = vload8(0, C + (m+n*ldc));*/
    /*c = c * beta + alpha * cp;*/
    /*vstore8(c, 0, C + (m+n*ldc));*/

}
