/***************************************************************************
 *cr
 *cr            (C) Copyright 2010 The Board of Trustees of the
 *cr                        University of Illinois
 *cr                         All Rights Reserved
 *cr
 ***************************************************************************/

/* 
 * Kernel of dense matrix-matrix multiplication kernel.
 * The algorithm is based on CUDA sgemm code from Vasily Volkov
 * at UC Berkeley.
 */

// CML x RML = CML, baseline version, 510FLOP/s on Fermi
/* Pseudo code
for i < M ; i += 64   // thread block.x
 for j < N; j += 16   // thread block.y
  for tx = 0; tx < 16; tx++ // thread index x; tile of M loop
  for ty = 0; ty < 4 ; ty++ // thread index y; tile of M loop

  for m < 16; m += 1;
     c[m] = 0.0f

  for k < K; k += 4   // seq

   b[ty][tx] = B[k+ty][j+tx]

   for l < 4; l +=1   // seq
    for m < 16; m +=1 // seq
      c[m] += A[i+ty*16+tx][k+l]+b[l][m]

*/
#define TILE 33
__kernel void square(
    __global float *input,
    __global float *output,
    /*__local float *temp,*/
    const unsigned int count)
{
    int gtid = get_global_id(0);
    int ltid = get_local_id(0);
    __local float temp[TILE];
    if (gtid < count)
    {
        temp[ltid] = input[gtid];
        barrier (CLK_LOCAL_MEM_FENCE);
        // if the threads were reading data from other threads, then we would
        // want a barrier here to ensure the write completes before the read
        output[gtid] =  temp[ltid] * temp[ltid];
    }
}
/*__kernel void mysgemmNT(__global const float *A, int lda, __global const float *B, int ldb, __global float* C, int ldc, int k, float alpha, float beta)*/
/*{*/
  /*__local float bs [TILE];*/
    /*bs[get_global_id(0)] = A[get_global_id(0)];*/
  
  /*for(int i =0; i<TILE; i++)*/
    /*bs[i] = bs[i] + B[i+get_global_id(0)];*/

  /*for(int i =0; i<TILE-1; i++)*/
     /*bs[i] = bs[i] + bs[i+1];*/

  /*for(int i =0; i<TILE; i++)*/
    /*C[i+get_global_id(0)] = bs[i];*/
/*}*/

