#include <endian.h>
#include <stdlib.h>
#include <stdio.h>
#include <inttypes.h>

#if __BYTE_ORDER != __LITTLE_ENDIAN
# error "File I/O is not implemented for this system: wrong endianness."
#endif

static int generate_vector(float *x_vector, int dim)
{
    srand(54321);
    int i;
    for(i=0; i<dim; i++)
    {
        x_vector[i] = (rand() / (float) RAND_MAX);
    }
    return 0;
}

void outputData(char* fName, float *A0, int dim)
{
  FILE* fid = fopen(fName, "w");
  if (fid == NULL)
    {
      fprintf(stderr, "Cannot open output file\n");
      exit(-1);
    }
  
  fwrite(A0, sizeof(float), dim, fid);

  fclose (fid);
}

int main(int argc, char** argv) {

  int dim;
  dim = atoi(argv[1]);
  char * writefn = argv[2];
  float *outV = (float*) malloc(dim * sizeof(float));
  generate_vector(outV, dim);
  outputData(writefn, outV, dim);

  return 0;
}
